! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      subroutine mati(arr,norder,det)

      use param
      use dal
      use emldata

      integer     ierr,k,norder,i,j,l
      double precision arr(max_par,max_par),amax,save,det
      integer     ik(max_par),jk(max_par)

      ierr=0

10    det=1.
11    do k=1,norder

! find largest element arr(i,j) in rest of matrix.
        amax=0.d0
21      do i=k,norder
          do j=k,norder
23          if(dabs(amax)-dabs(arr(i,j)))24,24,30
24          amax=arr(i,j)
            ik(k)=i
            jk(k)=j
30          continue
          enddo
        enddo

! interchange rows and columns to put amax in arr(k,k)
31      if(amax)41,32,41
32      det=0.
        go to 140
41      i=ik(k)
        if(i-k)21,51,43
43      do j=1,norder
          save=arr(k,j)
          arr(k,j)=arr(i,j)
          arr(i,j)=-save
        enddo
51      j=jk(k)
        if(j-k)21,61,53
53      do i=1,norder
          save=arr(i,k)
          arr(i,k)=arr(i,j)
          arr(i,j)=-save
        enddo

! accumulate elements of inverse matrix
61      do i=1,norder
          if(i-k)63,70,63
63        arr(i,k)=-arr(i,k)/amax
70        continue
        enddo
71      do i=1,norder
          do j=1,norder
            if(i-k)74,80,74
74          if(j-k)75,80,75
75          arr(i,j)=arr(i,j)+arr(i,k)*arr(k,j)
80          continue
          enddo
        enddo
81      do j=1,norder
          if(j-k)83,90,83
83        arr(k,j)=arr(k,j)/amax
90        continue
        enddo
        arr(k,k)=1./amax
        det=det*amax
      enddo

! restore ordering of matrix
101   do l=1,norder
        k=norder-l+1
        j=ik(k)
        if(j-k)111,111,105
105     do i=1,norder
          save=arr(i,k)
          arr(i,k)=-arr(i,j)
          arr(i,j)=save
        enddo
111     i=jk(k)
        if(i-k)130,130,113
113     do j=1,norder
          save=arr(k,j)
          arr(k,j)=-arr(i,j)
          arr(i,j)=save
        enddo
130     continue
      enddo
140   continue

      end subroutine mati



